var Dialog = (function() {
  var bg = document.createElement("div");
  bg.style.position = "fixed";
  bg.style.left = "0px";
  bg.style.right = "0px";
  bg.style.top = "0px";
  bg.style.bottom = "0px";
  bg.style.backgroundColor = "#000000";
  bg.style.opacity = 0.5;
  bg.style.filter = "alpha(opacity=50)";
  var popup = document.createElement("div");
  popup.style.position = "absolute";
  popup.style.backgroundColor = "#ffffff";
  popup.style.top = "100px";
  popup.style.left = "100px";
  var dialog = {
    show: function(html, callback) {
      dialog.callback = callback;
      popup.innerHTML = html;
      document.body.appendChild(bg);
      document.body.appendChild(popup);
      if (callback != null && typeof(callback.load) == 'function') {
        callback.load(popup);
      }
    },
    hide: function() {
      if (dialog.callback != null && typeof(dialog.callback.unload) == 'function') {
        dialog.callback.unload(popup);
      }
      document.body.removeChild(popup);
      document.body.removeChild(bg);
    }
  };
  bg.addEventListener('click', function() {
    dialog.hide();
  });
  return dialog;
})();
