<%@ Page Language="C#" EnableViewState="false" Debug="true"%>
<%@ Import namespace="System.Collections.Generic" %>
<%@ Import namespace="System.Data.SqlClient" %>
<%@ Import namespace="System.Web" %>
<%@ Import namespace="System.Web.Script.Serialization" %>
<%
var ser = new JavaScriptSerializer();
var user = (int?)Session["member"];
if (user == null)
{
  Response.Write(ser.Serialize(new { message = "OCĂ"}));
  Response.End();
}
var result = new object();
using (var connection = new SqlConnection("Data Source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|domodb.mdf;User Instance=true"))
{
  connection.Open();
  using (var command = connection.CreateCommand())
  {
    if (Request.HttpMethod == "GET") {
      Func<SqlDataReader, object> newObject = null;
      var id = string.Empty;
      if (Request.Params["creator"] != null) {
        id = Request.Params["creator"];
        command.CommandText = @"
select m.name,e.unit * r.amount_per_unit as amount
    from entries e
    inner join members m on e.member_id = m.id
    left outer join rosters r on e.roster_id = r.id
  where r.id=@id and r.creator=@user and e.unit<>0";
        newObject = r => 
            new { name = r["name"] as string, amount = r["amount"] as int? };
      } else if (Request.Params["owner"] != null) {
        id = Request.Params["owner"];
        command.CommandText = @"
select m.name,m.zip,m.address from entries e
    inner join members m on e.member_id = m.id
    left outer join rosters r on e.roster_id = r.id
  where r.id=@id and r.owner=@user and e.unit<>0";
        newObject = r => new {
          name = r["name"] as string,
          zip = r["zip"] as string,
          address = r["address"] as string
        };
      } else {
        Response.Write("{}");
        Response.End();
      }
      command.Parameters.Add(new SqlParameter("@id", id));
      command.Parameters.Add(new SqlParameter("@user", user));
      var list = new List<object>();
      using (var reader = command.ExecuteReader())
      {
        while (reader.Read())
        {
          list.Add(newObject(reader));
        }
      }
      result = list.ToArray();
    } else if (Request.HttpMethod == "POST") {
      command.CommandText = @"
insert into rosters
  values (@subject, @creator, @owner, @amount_per_unit, @maxunit, @location,
          @expire_date, sysdatetime())";
      string[] names = {"subject", "owner", "amount_per_unit", "maxunit", "location", "expire_date"};
      command.Parameters.Add(new SqlParameter("@creator", user));
      foreach (var name in names)
      {
        var val = (Request.Params[name] == null)
          ? (object)DBNull.Value : (object)Request.Params[name];
        command.Parameters.Add(new SqlParameter("@" + name, val));
      }
      command.ExecuteNonQuery();
    }
    connection.Close();
  }
}
%>
<%= ser.Serialize(result) %>
