(function() {
  var create = function(tbl, content, onload) {
    Dialog.show('<div>' + tbl + '</div>'
      + '<form method="post" id="create_form">'
      + '<label>目的/開催日時<input type="text" name="subject" size="64" required></label><br/>'
      + '<label>掲示期限<input type="date" name="expire_date" placeholder="yyyy/mm/dd" required></label><br/>'
      + content()
      + '<input type="submit" value="作成"/>'
      + '</form>',
      {
        load: function(popup) {
          var form = document.getElementById('create_form');
          form.addEventListener('submit', function(e) {
            var xtr = Util.createXtr(function() {
              var result = JSON.parse(xtr.responseText);
              if (result.message != null) {
                alert(result.message);
              } else {
                document.getElementById('update_rosters').click();
              }
              Dialog.hide();
            });
            var data = '';
            for (var i = 0; i < form.elements.length; i++) {
              if (i > 0) data += '&';
              data += form.elements[i].name + '=' + encodeURIComponent(form.elements[i].value);
            }
            Util.postData(xtr, 'entries.aspx', data);
            e.preventDefault();
          });
          if (onload != null) onload(form);
        }
      });
  };
  document.getElementById("create_entrylist").addEventListener('click', function() {
    create('参加表', function() {
      return '<label>参加費用<input type="text" name="amount_per_unit" size="5"></label><br/>'
           + '<label>場所<input type="text" name="location" size="64"></label><br/>';
    });
  });
  document.getElementById("create_collection").addEventListener('click', function() {
    create('慶弔金表', function() {
      return '<label>贈り先<select name="owner" id="owner"></select></label><br/>'
           + '<label>金額/口<input type="text" name="amount_per_unit" size="5" required></label><br/>'
           + '<label>最大口数<input type="text" name="maxunit" size="2" required></label><br/>';
    },
    function(form) {
      var xtr = Util.createXtr(function() {
        var recs = JSON.parse(xtr.responseText);
        var opt = [];
        for (var i = 0; i < recs.length; i++) {
          opt[i] = '<option value="' + recs[i].id + '">' 
               + Util.htmlEscape(recs[i].name) + '</option>';
        }
        form.elements['owner'].innerHTML = opt.join('');
      });
      xtr.open('GET', 'members.aspx', true);
      xtr.send(null);
    });
  });
})();