<%@ Page Language="C#" EnableViewState="false" Debug="true"%>
<%@ Import namespace="System.Collections.Generic" %>
<%@ Import namespace="System.Data.SqlClient" %>
<%@ Import namespace="System.Web" %>
<%@ Import namespace="System.Web.Script.Serialization" %>
<%
if (Request.HttpMethod == "POST" && Request.Params["logout"] != null)
{
  Session["member"] = null;
  Response.Write("{}");
  Response.End();
}
var result = new object();
using (var connection = new SqlConnection("Data Source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|domodb.mdf;User Instance=true"))
{
  connection.Open();
  using(var command = connection.CreateCommand())
  {
    var user = Session["member"] as int?;
    if (Request.HttpMethod == "POST")
    {
      if (Request.Params["save"] != null)
      {
        if (user == null)
        {
          Response.End();
        }
        var psw = Request.Params["psw"];
        command.CommandText = string.Format("update members set zip=@zip,address=@address{0} where id=@id",
          ((psw != null) ? ",password=@psw" : string.Empty));
        command.Parameters.Add(new SqlParameter("@zip", Request.Params["zip"]));
        command.Parameters.Add(new SqlParameter("@address", Request.Params["address"]));
        if (psw != null)
        {
          command.Parameters.Add(new SqlParameter("@psw",
            string.IsNullOrEmpty(psw) ? (object)DBNull.Value : (object)psw));
        }
        command.Parameters.Add(new SqlParameter("@id", user));
        result = new { affected = command.ExecuteNonQuery() };
      }
      else
      {
        if (string.IsNullOrEmpty(Request.Params["psw"]))
        {
          command.CommandText = "select id, name from members where id=@id and password is null";
        }
        else
        {
          command.CommandText = "select id, name from members where id=@id and password=@psw";
          command.Parameters.Add(new SqlParameter("@psw", Request.Params["psw"]));
        }
        command.Parameters.Add(new SqlParameter("@id", Request.Params["id"]));
        using (var reader = command.ExecuteReader())
        {
          if (reader.Read())
          {
            Session["member"] = reader["id"];
            result = new { id = (int)reader["id"], name = reader["name"] as string };
          }
        }
      }
    }
    else if (Request.Params["q"] == "edit")
    {
      if (user == null)
      {
        Response.End();
      }
      command.CommandText = "select * from members where id=@id";
      command.Parameters.Add(new SqlParameter("@id", user));
      using (var reader = command.ExecuteReader())
      {
        if (reader.Read())
        {
          result = new { id = (int)reader["id"],
                         name = reader["name"] as string,
                         zip = reader["zip"] as string,
                         address = reader["address"] as string,
                       };
        }
        else
        {
          Session["member"] = null;
        }
      }
    }
    else
    {
      var list = new List<object>();
      command.CommandText = "select id, name from members order by name";
      using (var reader = command.ExecuteReader())
      {
        while (reader.Read())
        {
          list.Add(new {id = (int)reader["id"], name = reader["name"] as string});
        }
      }
      result = list.ToArray();
    }
  }
  connection.Close();
}
var ser = new JavaScriptSerializer();
%>
<%= ser.Serialize(result) %>
