<%@ Page Language="C#" EnableViewState="false" Debug="true"%>
<%@ Import namespace="System.Collections.Generic" %>
<%@ Import namespace="System.Data.SqlClient" %>
<%@ Import namespace="System.Web" %>
<%@ Import namespace="System.Web.Script.Serialization" %>
<%
var result = new object();
using (var connection = new SqlConnection("Data Source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|domodb.mdf;User Instance=true"))
{
  connection.Open();
  using(var command = connection.CreateCommand())
  {
    var user = (int?)Session["member"];
    if (user == null)
    {
      Response.Write("{}");
      Response.End();
    }

    if (Request.HttpMethod == "GET")
    {
      command.CommandText
        = @"
select r.id
      ,subject
      ,r.amount_per_unit
      ,isnull(r.maxunit, 0) as maxunit
      ,location
      ,convert(varchar, expire_date, 111) as expire_date
      ,m.name as creator_name
      ,r.creator as creator_id
      ,r.owner as owner_id
      ,isnull(e.unit, 0) as user_unit
   from rosters r inner join members m on r.creator=m.id
             left outer join entries e on r.id=e.roster_id and e.member_id=@user
   where expire_date > convert(date, sysdatetime())
   order by expire_date asc
";
      command.Parameters.Add(new SqlParameter("@user", user));
      var list = new List<object>();
      using (var reader = command.ExecuteReader())
      {
        while (reader.Read())
        {
          list.Add(new {id = (int)reader["id"],
                        subject = reader["subject"] as string,
                        amount_per_unit = reader["amount_per_unit"] as int?,
                        maxunit = reader["maxunit"] as int?,
                        location = reader["location"] as string,
                        expire_date = reader["expire_date"] as string,
                        creator_name = reader["creator_name"] as string,
                        user_unit = reader["user_unit"] as int?,
                        creator = user == reader["creator_id"] as int?,
                        owner = user == reader["owner_id"] as int?
                       });
        }
      }
      result = list.ToArray();
    } else if (Request.HttpMethod == "POST") {
      command.CommandText = @"
update entries set unit=@unit where roster_id=@id and member_id=@user";
      command.Parameters.Add(new SqlParameter("@unit", Request.Params["unit"]));
      command.Parameters.Add(new SqlParameter("@id", Request.Params["id"]));
      command.Parameters.Add(new SqlParameter("@user", user));
      var affected = command.ExecuteNonQuery();
      if (affected == 0) {
        command.CommandText = @"
insert into entries values (@id, @user, @unit, sysdatetime())";
        command.ExecuteNonQuery();
      }
    }
  }
  connection.Close();
}
var ser = new JavaScriptSerializer();
%>
<%= ser.Serialize(result) %>
