(function () {
  var login = document.getElementById('login');
  var member_name = document.getElementById('member_name');
  var changeUI = function(f) {
    var uielems = [['labelMember', 'inline', 'none'],
                   ['labelPsw', 'inline', 'none'],
                   ['labelName', 'none', 'inline'],
                   ['commands', 'none', 'block'],
                   ['rosters', 'none', 'block']];
    for (var i = 0; i < uielems.length; i++) {
      var elem = document.getElementById(uielems[i][0]);
      elem.style.display = f ? uielems[i][1] : uielems[i][2];
    }
    login.value = f ? 'login' : 'logout';
  };
  var nullToEmpty = function(val) {
    return (val == null) ? '' : val;
  };
  login.addEventListener('click', function() {
    if (login.value == 'login') {
      var member = document.getElementById('member');
      var psw = document.getElementById('psw');
      if (member.value != '') {
        var xtr = new XMLHttpRequest();
        xtr.onload = function() {
          var result = JSON.parse(xtr.responseText);
          if (result.id != null) {
            member_name.innerHTML = Util.htmlEscape(result.name);
            member_name.href = "members.aspx?q=edit";
            changeUI(false);
            document.getElementById('update_rosters').click();
          } else {
            psw.value = '';
          }
        };
        Util.postData(xtr, 'members.aspx', 
          'id=' + encodeURIComponent(member.value) + '&psw=' + encodeURIComponent(psw.value));
      }
    } else { // logout
      var xtr = new XMLHttpRequest();
      Util.postData(xtr, 'members.aspx', 'logout=true');
      changeUI(true);
      document.getElementById('rosters').innerHTML = '';
    }
  });
  member_name.addEventListener('click', function(e) {
    var xtr = Util.createXtr(function() {
      var member = JSON.parse(xtr.responseText);
      if (member.name == null) {
        changeUI(true);
        document.getElementById('rosters').innerHTML = '';
      }
      Dialog.show('<div>' + member.name + '</div>'
        + '<form method="post" id="member_form">'
        + '<label>郵便番号<input type="text" name="zip" placeholder="郵便番号" size="8"/></label><br/>'
        + '<label>住所<input type="text" name="address" placeholder="住所" size="64"/></label><br/>'
        + '<label>パスワード更新<input type="checkbox" name="update_psw" value="true"/></label>'
        + '<input type="text" name="psw" placeholder="password"/></form>',
        {
          load: function(popup) {
            var form = document.getElementById('member_form');
            var elems = ['zip', 'address'];
            for (var i = 0; i < elems.length; i++) {
              form.elements[elems[i]].value = nullToEmpty(member[elems[i]]);
            }
          },
          unload: function(popup) {
            var form = document.getElementById('member_form');
            var xtr = new XMLHttpRequest();
            var data = 'zip=' + encodeURIComponent(form.elements['zip'].value)
                   + '&address=' + encodeURIComponent(form.elements['address'].value)
                   + '&save=true';
            if (form.elements['update_psw'].checked) {
               data += '&psw=' + encodeURIComponent(form.elements['psw'].value)
            }
            Util.postData(xtr, member_name.href, data);
          }
        }
      );
    });
    xtr.open('GET', member_name.href, true);
    xtr.send(null);
    e.preventDefault();
  });
  var xtr = Util.createXtr(function() {
    var recs = JSON.parse(xtr.responseText);
    var opt = [];
    for (var i = 0; i < recs.length; i++) {
      opt[i] = '<option value="' + recs[i].id + '">' 
           + Util.htmlEscape(recs[i].name) + '</option>';
    }
    document.getElementById('member').innerHTML = opt.join('');
  });
  xtr.open('GET', 'members.aspx', true);
  xtr.send(null);
})();