var Util = {
  htmlEscape: function(s) {
    if (typeof s == 'string') {
      return s.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
    } else {
      return s;
    }
  },
  createXtr: function(onload) {
    var xtr = new XMLHttpRequest();
    xtr.onload = function() {
      if (xtr.status != 200) {
        xtr.onerror(xtr.responseText);
      } else {
        onload();
      }
    };      
    xtr.onerror = function(e) {
      alert(e);
    };
    return xtr;
  },
  postData: function(xtr, href, data) {
    xtr.open('POST', href, true);
    xtr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xtr.send(data);
  }
};
